#ifdef __WIN32__
#include <windows.h>
#include <windowsx.h>
#include <commctrl.h>
#include <vfw.h>
#else
#include "ideastypes.h"
#endif
#include "../pluginmain.h"
#include "res.h"
#include "guid.h"

//---------------------------------------------------------------------------
#ifdef __WIN32__
AVICOMPRESSOPTIONS *aopts[1], opts;
PAVIFILE pFile;
PAVISTREAM pVideoStream, pVideoCompressedStream, pAudioStream;//, pAudCompress;
WAVEFORMATEX wfex;
#endif
HINSTANCE hInst; HANDLE hCon; HWND hwnd=NULL;
DWORD nVideoSamples, nAudioSamples;
BOOL bPromptAviFileName = TRUE, bEnabledCompression = FALSE, bEnableAud=TRUE, open;
char szFileName[MAX_PATH] = ".\\out.avi", sz[256]; DWORD dw;
//---------------------------------------------------------------------------
static BOOL StartCapture( DWORD );
static BOOL AddVideoFrame( unsigned short*, unsigned short* );
static BOOL AddAudioSample( void*, int, void*, int );
static BOOL CreateVideoStream( BOOL );
static BOOL CreateAudioStream();
static BOOL BrowseForFile();
//---------------------------------------------------------------------------
#ifdef __WIN32__
extern "C" BOOL APIENTRY DllMain( HINSTANCE hInst, DWORD reason, LPVOID reserved )
{
	switch (reason) {
		case DLL_PROCESS_ATTACH:
			::hInst = hInst;
			pFile = NULL;
			pVideoStream = NULL;
			pVideoCompressedStream = NULL;
			pAudioStream = NULL;
			aopts[0] = &opts;
			//AllocConsole();
			hCon = GetStdHandle(STD_OUTPUT_HANDLE);
			break;
		case DLL_PROCESS_DETACH:
			//FreeConsole();
			break;
		case DLL_THREAD_ATTACH:
			//AllocConsole();
			//hCon = GetStdHandle(STD_OUTPUT_HANDLE);
			break;
		case DLL_THREAD_DETACH:
			//FreeConsole();
			break;
	}
	return TRUE;
}
#endif

//---------------------------------------------------------------------------
extern "C" DWORD __declspec(dllexport) I_STDCALL GetInfoFunc( LPGETPLUGININFO p )
{
	wsprintf( sz, "GetInfoFunc() Index:%i, wType:0x%X, dwType:0x%X, Language ID:%i\n",
		p->wIndex, p->wType, p->dwType, p->dwLanguageID ); DWORD dw;
	WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
	switch (p->wIndex) {
		case 1:
			p->dwType = PIT_DYNAMIC | PIT_GRAPHICS | PIT_NOMODIFY | PIT_ISFILTER | PIT_NOEXCLUSIVE;
			if( p->pszText != NULL ) {
				switch (LOWORD(p->dwLanguageID)) {
					default:
						lstrcpyn( (LPSTR)p->pszText, "AviCapture", p->cchTextMax );
						break;
				}
			}
			*(&p->guidID) = *(&IDEASAVICAPTURE);
			break;
		case 2:
			p->dwType = PIT_DYNAMIC | PIT_AUDIO | PIT_NOMODIFY | PIT_NOMENU | PIT_ISFILTER | PIT_NOEXCLUSIVE;
			if( p->pszText != NULL ) {
				switch (LOWORD(p->dwLanguageID)) {
					default:
						lstrcpyn( (LPSTR)p->pszText, "AviCapture Audio", p->cchTextMax );
						break;
				}
			}
			*(&p->guidID) = *(&IDEASAVICAPTURE_AUDIO);
			break;
	}
	return 2;
}

//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) I_STDCALL SetInfoFunc( LPSETPLUGININFO p )
{
	/*wsprintf( sz, "SetInfoFunc() Index:%i, State:0x%X, StateMask:0x%X, Parameter:%X\n",
		p->wIndex, p->dwState, p->dwStateMask, p->lParam );
	WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
	if( p == NULL )
		return FALSE;
	switch (p->wIndex) {
		case 1:
			if( PLUGINISENABLE(p) ) {
				wsprintf( sz, "SetInfoFunc() Index:%i, Plugin is enabled\n", p->wIndex );
				WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
				//hwnd = GetActiveWindow();
				AVIFileInit();
				/*hHeap = GetProcessHeap();
				if( (::p = (BYTE*)HeapAlloc(hHeap, HEAP_ZERO_MEMORY, 256*384*sizeof(WORD))) == NULL )
					return FALSE;*/
			}
			if( PLUGINISRUN(p) ) {
				wsprintf( sz, "SetInfoFunc() Index:%i, Plugin is running\n", p->wIndex );
				WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
				if( !StartCapture( p->wIndex ) )
					return FALSE;
			} break;
		case 2:
			if( PLUGINISENABLE(p) ) {
				wsprintf( sz, "SetInfoFunc() Index:%i, Plugin is enabled\n", p->wIndex );
				WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
			}
			if( PLUGINISRUN(p) ) {
				wsprintf( sz, "SetInfoFunc() Index:%i, Plugin is running\n", p->wIndex );
				WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
				IPlugInManager *pim; DWORD dwSize=sizeof(WAVEFORMATEX);
				p->lpNDS->QueryInterface(IID_IPLUGINMANAGER, (void**)&pim);
				pim->get_PlugInFormat( PIT_AUDIO, &wfex, &dwSize );
				wsprintf( sz, "wfex:{%i,%i,%i,%i,%i,%i,%i}\n",
					wfex.wFormatTag, wfex.nChannels, wfex.nSamplesPerSec,
					wfex.nAvgBytesPerSec, wfex.nBlockAlign, wfex.wBitsPerSample, wfex.cbSize );
				WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
				if( bEnableAud )
					if( !StartCapture( p->wIndex ) )
						return FALSE;
			}
	}
    return TRUE;
}

//---------------------------------------------------------------------------
//extern "C" BOOL __declspec(dllexport) I_STDCALL RunFunc(WORD index,unsigned short *src,unsigned short*dst)
extern "C" BOOL __declspec(dllexport) I_STDCALL RunFunc( LPRUNPARAM rp )
{
	/*wsprintf( sz, "Index:%i Type:%X\n", rp->index, rp->type );
	//WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
	switch (rp->index) {
		case 1: //graphics
			/*wsprintf( sz, "%i, 0x%X, 0x%X\n", 
				rp->graphics.render, rp->graphics.mem1, rp->graphics.mem2 );
			//WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
			return AddVideoFrame( rp->graphics.mem1, rp->graphics.mem2 );
		case 2: //audio
			/*wsprintf( sz, "0x%X, %i, 0x%X, %i\n", 
				rp->audio.mem1, rp->audio.len1, rp->audio.mem2, rp->audio.len2 );
			//WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
			return AddAudioSample( rp->audio.mem1, rp->audio.len1, rp->audio.mem2, rp->audio.len2 );
	}
	return TRUE;
}

void ReleaseVideo()
{
	if( pVideoCompressedStream ) {
		AVIStreamRelease( pVideoCompressedStream );
		pVideoCompressedStream = NULL;
	}
	if( pVideoStream ) {
		AVIStreamRelease( pVideoStream );
		pVideoStream = NULL;
	}
}

void ReleaseAudio()
{
	/*if( pAudCompress ) {
		AVIStreamRelease( pAudCompress );
		pAudCompress = NULL;
	}*/
	if( pAudioStream ) {
		AVIStreamRelease( pAudioStream );
		pAudioStream = NULL;
	}
}

//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) I_STDCALL ResetFunc()
{
	if( hCon ) {
		wsprintf( sz, "ResetFunc()\n" );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
	}
#ifdef __WIN32__
	ReleaseAudio();
	ReleaseVideo();
#endif
	nVideoSamples = 0;
	nAudioSamples = 0;
	return TRUE;
}

//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) I_STDCALL DeleteFunc()
{
	wsprintf( sz, "DeleteFunc()\n" );
	WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
	if( !ResetFunc() )
		return FALSE;
	if( pFile ) {
		AVIFileRelease( pFile );
		pFile = NULL;
	}
#ifdef __WIN32__
	if( aopts[0]->lpParms != NULL )
		AVISaveOptionsFree( 1, /*(LPAVICOMPRESSOPTIONS FAR *)*/aopts );
	AVIFileExit();
#endif
	return TRUE;
}

//---------------------------------------------------------------------------
static BOOL CALLBACK DialogProc( HWND hDlg, UINT msg, WPARAM wParam, LPARAM lParam )
{
	switch (msg) {
		case WM_INITDIALOG:
			Edit_SetText( GetDlgItem(hDlg, IDC_FILENAME), szFileName );
			Button_SetCheck( GetDlgItem(hDlg, IDC_PROMPTAVINAME), (bPromptAviFileName ? BST_CHECKED:BST_UNCHECKED) );
			Button_SetCheck( GetDlgItem(hDlg, IDC_COMPRESSION), (bEnabledCompression ? BST_CHECKED:BST_UNCHECKED) );
			Button_SetCheck( GetDlgItem(hDlg, IDC_AUDIO), (bEnableAud ? BST_CHECKED:BST_UNCHECKED) );
			return TRUE;
		case WM_COMMAND:
			if( HIWORD(wParam) == 0 ) {
				switch (LOWORD(wParam)) {
					case IDC_BROWSE:
						if( BrowseForFile() ) {
							Edit_SetText( GetDlgItem(hDlg, IDC_FILENAME), szFileName );
							ReleaseAudio(); ReleaseVideo();
							if( pFile ) {
								AVIFileRelease( pFile );
								pFile = NULL;
								StartCapture( 1 ); StartCapture( 2 );
							}
						} break;
				}
			} break;
		case WM_NOTIFY:
			if( ((LPNMHDR)lParam)->code == PSN_APPLY ) {
				Edit_GetText( GetDlgItem(hDlg, IDC_FILENAME), szFileName, MAX_PATH );
				bPromptAviFileName = (Button_GetCheck(GetDlgItem(hDlg, IDC_PROMPTAVINAME)) == BST_CHECKED) ? TRUE:FALSE;
                bEnabledCompression = (Button_GetCheck(GetDlgItem(hDlg, IDC_COMPRESSION)) == BST_CHECKED) ? TRUE:FALSE;
                bEnableAud = (Button_GetCheck(GetDlgItem(hDlg, IDC_AUDIO)) == BST_CHECKED) ? TRUE:FALSE;
			} break;
	}
	return FALSE;
}

//---------------------------------------------------------------------------
extern "C" BOOL __declspec(dllexport) I_STDCALL SetPropertyFunc( LPSETPROPPLUGIN p )
{
	/*wsprintf( sz, "SetPropertyFunc() Parent Wnd:0x%X\n", p->hwndOwner );
	WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
	if( p->info.wIndex == 2 )
		return FALSE;
#ifdef __WIN32__
	PROPSHEETPAGE psp={0};
	HPROPSHEETPAGE hpsp;
	
	psp.dwSize = sizeof(PROPSHEETPAGE);
	psp.dwFlags = PSP_DEFAULT | PSP_USETITLE;
	psp.hInstance = hInst;
	psp.pfnDlgProc = DialogProc;
	psp.pszTemplate = MAKEINTRESOURCE(IDD_PROP);
	psp.pszTitle = "Avi Capture Plugin";
	hpsp = CreatePropertySheetPage(&psp);
	if( hpsp == NULL )
		return FALSE;
	return PropSheet_AddPage( (HWND)p->hwndOwner, hpsp );
#else
	return FALSE;
#endif
}

//---------------------------------------------------------------------------
static BOOL AddVideoFrame( unsigned short *src0, unsigned short *src1 )
{
#ifdef __WIN32__
	LONG lFrames;
	BYTE *pVid;
	PAVISTREAM pAvi;
	
	pAvi = pVideoCompressedStream != NULL ? pVideoCompressedStream : pVideoStream;
	if( pAvi == NULL || src0 == NULL || src1 == NULL )
		return FALSE;
	pVid = (BYTE*)GlobalAlloc(GPTR, 256*384*sizeof(WORD));
	CopyMemory( pVid, src0, 256*192*sizeof(WORD) );
	pVid += 256*192*sizeof(WORD);
	CopyMemory( pVid, src1, 256*192*sizeof(WORD) );
	pVid -= 256*192*sizeof(WORD);
	AVIStreamWrite( pAvi, nVideoSamples, 1, pVid, 256*384*sizeof(WORD), 0, &lFrames, NULL );
	nVideoSamples += lFrames;
	GlobalFree( pVid );
#endif
	return TRUE;
}

//---------------------------------------------------------------------------
static BOOL AddAudioSample( void *src0, int len1, void *src1, int len2 )
{
#ifdef __WIN32__
	LONG lSamples;
	BYTE *pAud;
	//PAVISTREAM pAvi;
	
	//pAvi = pAudCompress!=NULL?pAudCompress:pAudioStream;
	if( pAudioStream == NULL || src0 == NULL || src1 == NULL )
		return FALSE;
	pAud = (BYTE*)GlobalAlloc(GPTR, len1+len2);
	CopyMemory( pAud, src0, len1 );
	pAud += len1;
	CopyMemory( pAud, src1, len2 );
	pAud -= len1;
	//wfex.nSamplesPerSec==22050?(len1+len2):(len1+len2)/2
	AVIStreamWrite( pAudioStream, nAudioSamples, (len1+len2)/wfex.nBlockAlign, pAud, len1+len2, 0, &lSamples, NULL );
	nAudioSamples += lSamples;
	GlobalFree( pAud );
#endif
	return TRUE;
}

//---------------------------------------------------------------------------
static BOOL BrowseForFile()
{
#ifdef __WIN32__	
	OPENFILENAME ofn={0};
	
	ofn.lStructSize	= sizeof(OPENFILENAME);
	ofn.hInstance =	hInst;
	ofn.lpstrFilter	= "AVI Files (*.avi)\0*.avi\0\0\0";
	ofn.lpstrFile =	szFileName;
	ofn.Flags =	OFN_EXPLORER | OFN_CREATEPROMPT | OFN_OVERWRITEPROMPT;
	ofn.nMaxFile = MAX_PATH;
	ofn.lpstrDefExt	= "avi";
	if( !GetSaveFileName(&ofn) )
		return FALSE;
#endif
	return TRUE;
}

//---------------------------------------------------------------------------
static BOOL StartCapture( DWORD indx )
{
	if( pFile == NULL ) {
		if( bPromptAviFileName ) {
			if( !BrowseForFile() )
				return FALSE;
		}
		int res = AVIFileOpen(&pFile, szFileName, OF_WRITE|OF_CREATE|OF_SHARE_EXCLUSIVE, NULL);
		/*wsprintf( sz, "res:%X\n", res );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
		if( res )
			return FALSE;
	}
	switch (indx) {
		case 1:
			//ReleaseVideo(); nVideoSamples = 0;
			if( !CreateVideoStream(bEnabledCompression?TRUE:FALSE) ) {
				/*wsprintf( sz, "%s", "CreateVideoStream returned FALSE\n" );
				WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
				return FALSE;
			} break;
		case 2:
			//ReleaseAudio(); nAudioSamples = 0;
			if( !CreateAudioStream() ) {
				/*wsprintf( sz, "%s", "CreateAudioStream returned FALSE\n" );
				WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
				return FALSE;
			}
	}
	return TRUE;
}

//---------------------------------------------------------------------------
static BOOL CreateVideoStream(BOOL bStreamCompressed)
{
#ifdef __WIN32__
	AVISTREAMINFO avisi;
	BITMAPINFOHEADER bih;
	int	res;
	
	if( pVideoStream == NULL ) {
		ZeroMemory( &avisi, sizeof(AVISTREAMINFO) );
		avisi.fccType =	streamtypeVIDEO;
		avisi.dwScale =	1;
		avisi.dwRate = 60;
		//avisi.dwSuggestedBufferSize = 256*384*sizeof(WORD);
		avisi.dwQuality = (DWORD)ICQUALITY_DEFAULT;
		avisi.rcFrame.right = 256;
		avisi.rcFrame.bottom = 384;
		res = AVIFileCreateStream(pFile, &pVideoStream, &avisi);
		/*wsprintf( sz, "res:%X\n", res );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
		if( res )
			return FALSE;
		
		
		if( !bStreamCompressed ) {
			ZeroMemory( &bih, sizeof(BITMAPINFOHEADER) );
			bih.biSize = sizeof(BITMAPINFOHEADER);
			bih.biWidth = 256;
			bih.biHeight = -384;
			bih.biPlanes = 1;
			bih.biBitCount = 16;
			bih.biCompression = BI_RGB;
			//bih.biSizeImage = 256*384*sizeof(WORD);
			res	= AVIStreamSetFormat(pVideoStream, 0, &bih, sizeof(BITMAPINFOHEADER));
			/*wsprintf( sz, "res:%X\n", res );
			WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
			if( res )
				return FALSE;
			return TRUE;
		}
	}
	if( pVideoCompressedStream == NULL && bEnabledCompression ) {
		ZeroMemory( &opts, sizeof(opts) );
		wsprintf( sz, "0x%X,0x%X,%d,%d,%d,0x%X,0x%X,%d,0x%X,%d,%d\n", 
			opts.fccType, opts.fccHandler, opts.dwKeyFrameEvery, opts.dwQuality, 
			opts.dwBytesPerSecond, opts.dwFlags, opts.lpFormat, opts.cbFormat, 
			opts.lpParms, opts.cbParms, opts.dwInterleaveEvery );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
		res = AVISaveOptions(NULL, 0, 1, &pVideoStream, /*(LPAVICOMPRESSOPTIONS*)*/aopts);
		if( res == FALSE ) {
			/*wsprintf( sz, "res:%X\n", res );
			WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
			res=AVISaveOptionsFree( 1, /*(LPAVICOMPRESSOPTIONS*)*/aopts );
			/*wsprintf( sz, "res:%X\n", res );
			WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
			return FALSE;
		}
		/*wsprintf( sz, "0x%X,0x%X,%d,%d,%d,0x%X,0x%X,%d,0x%X,%d,%d\n",
			opts.fccType, opts.fccHandler, opts.dwKeyFrameEvery, opts.dwQuality,
			opts.dwBytesPerSecond, opts.dwFlags, opts.lpFormat, opts.cbFormat,
			opts.lpParms, opts.cbParms, opts.dwInterleaveEvery );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
		res = AVIMakeCompressedStream(&pVideoCompressedStream, pVideoStream, &opts, NULL);
		/*wsprintf( sz, "res:%X\n", res );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
		if( res )
			return FALSE;
		/*wsprintf( sz, "0x%X,0x%X,%d,%d,%d,0x%X,0x%X,%d,0x%X,%d,%d\n",
			opts.fccType, opts.fccHandler, opts.dwKeyFrameEvery, opts.dwQuality,
			opts.dwBytesPerSecond, opts.dwFlags, opts.lpFormat, opts.cbFormat,
			opts.lpParms, opts.cbParms, opts.dwInterleaveEvery );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
		res=AVISaveOptionsFree( 1, /*(LPAVICOMPRESSOPTIONS*)*/aopts );
		/*wsprintf( sz, "res:%X\n", res );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
		wsprintf( sz, "0x%X,0x%X,%d,%d,%d,0x%X,0x%X,%d,0x%X,%d,%d\n",
			opts.fccType, opts.fccHandler, opts.dwKeyFrameEvery, opts.dwQuality,
			opts.dwBytesPerSecond, opts.dwFlags, opts.lpFormat, opts.cbFormat,
			opts.lpParms, opts.cbParms, opts.dwInterleaveEvery );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
		ZeroMemory( &bih, sizeof(BITMAPINFOHEADER) );
		bih.biSize = sizeof(BITMAPINFOHEADER);
		bih.biWidth = 256;
		bih.biHeight = -384;
		bih.biPlanes = 1;
		bih.biBitCount = 16;
		bih.biCompression = opts.fccHandler;
		//bih.biSizeImage = 256*384*sizeof(WORD);
		/*wsprintf( sz, "0x%X,0x%X,%d,%d,%d,0x%X,0x%X,%d,0x%X,%d,%d\n",
			opts.fccType, opts.fccHandler, opts.dwKeyFrameEvery, opts.dwQuality,
			opts.dwBytesPerSecond, opts.dwFlags, opts.lpFormat, opts.cbFormat,
			opts.lpParms, opts.cbParms, opts.dwInterleaveEvery );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
		res = AVIStreamSetFormat(pVideoCompressedStream, 0, &bih, sizeof(BITMAPINFOHEADER));
		/*wsprintf( sz, "res:%X\n", res );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );*/
		if( res ) {
			ReleaseVideo();
			return FALSE;
		}
	}
#endif
	return TRUE;
}

static BOOL CreateAudioStream()
{
	AVISTREAMINFO avisi;
	int	res;
	
	if( pAudioStream == NULL ) {
		ZeroMemory( &avisi, sizeof(AVISTREAMINFO) );
		avisi.fccType =	streamtypeAUDIO;
		avisi.dwScale =	wfex.nBlockAlign;
		avisi.dwRate = wfex.nAvgBytesPerSec;
		avisi.dwInitialFrames = 1;
		avisi.dwSampleSize = wfex.nBlockAlign;
		avisi.dwQuality	= (DWORD)ICQUALITY_DEFAULT;
		res = AVIFileCreateStream(pFile, &pAudioStream, &avisi);
		if( res )
			return FALSE;
		res	= AVIStreamSetFormat(pAudioStream, 0, &wfex, sizeof(WAVEFORMATEX));
		if( res )
			return FALSE;
	}
	/*if( pAudCompress == NULL ) {
		ZeroMemory( &opts, sizeof(AVICOMPRESSOPTIONS) );
		wsprintf( sz, "%X,%X,%d,%d,%d,%X,%X,%d,%X,%d,%d\n", 
			opts.fccType, opts.fccHandler, opts.dwKeyFrameEvery, opts.dwQuality, 
			opts.dwBytesPerSecond, opts.dwFlags, opts.lpFormat, opts.cbFormat, 
			opts.lpParms, opts.cbParms, opts.dwInterleaveEvery );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
		opts.lpFormat = &wfex; opts.cbFormat = sizeof(WAVEFORMATEX);
		//opts.dwFlags |= AVICOMPRESSF_VALID;
		if( !AVISaveOptions(hwnd, 0, 1, &pAudioStream, aopts) ) {
			AVISaveOptionsFree( 1, aopts );
			return FALSE;
		}
		res = AVIMakeCompressedStream(&pAudCompress, pAudioStream, &opts, NULL);
		wsprintf( sz, "%X,%X,%d,%d,%d,%X,%X,%d,%X,%d,%d,res:%X",
			opts.fccType, opts.fccHandler, opts.dwKeyFrameEvery, opts.dwQuality,
			opts.dwBytesPerSecond, opts.dwFlags, opts.lpFormat, opts.cbFormat,
			opts.lpParms, opts.cbParms, opts.dwInterleaveEvery, res );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
		if( res )
			return FALSE;
		AVISaveOptionsFree( 1, aopts );
		wsprintf( sz, "%X,%X,%d,%d,%d,%X,%X,%d,%X,%d,%d",
			opts.fccType, opts.fccHandler, opts.dwKeyFrameEvery, opts.dwQuality,
			opts.dwBytesPerSecond, opts.dwFlags, opts.lpFormat, opts.cbFormat,
			opts.lpParms, opts.cbParms, opts.dwInterleaveEvery );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
		res = AVIStreamSetFormat(pAudCompress, 0, &wfex, sizeof(WAVEFORMATEX));
		wsprintf( sz, "%X,%X,%d,%d,%d,%X,%X,%d,%X,%d,%d,res:%X",
			opts.fccType, opts.fccHandler, opts.dwKeyFrameEvery, opts.dwQuality,
			opts.dwBytesPerSecond, opts.dwFlags, opts.lpFormat, opts.cbFormat,
			opts.lpParms, opts.cbParms, opts.dwInterleaveEvery, res );
		WriteConsole( hCon, sz, lstrlen(sz), &dw, NULL );
		if( res ) {
			if( pAudCompress != NULL ) {
				AVIStreamRelease( pAudCompress );
				pAudCompress = NULL;
			}
			return FALSE;
		}
	}*/
	return TRUE;
}

static BOOL WriteToLog()
{
	static HANDLE hLog; DWORD dw;
	if( !open )
		open = (hLog = CreateFile("avi.log", GENERIC_WRITE, FILE_SHARE_READ, NULL,
			OPEN_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL))!=NULL;
	if( open ) {
		open = TRUE;
		WriteFile( hLog, sz, lstrlen(sz), &dw, NULL );
		//MessageBox( NULL, sz, "", MB_OK );
	}
	if( !open )
		CloseHandle( hLog );
	return open;
}
